-- Skrypt na podstawie Sipmy N-247 by Grzegorz056 i hannibal5
--
-- Sipma N247 
-- first edit By Grzegorz056
-- Dodanie nowych funkcji by Magik
--
-- 02.05.2011r.


SipmaN2479 = {};

function SipmaN2479.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function SipmaN2479:load(xmlFile)
	
	-----------------------------ADAPTER----------------------------
	self.walek = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.walek#index"));
	self.walek2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.walek2#index"));
	self.walek3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.walek3#index"));
	self.walek46 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.walek46#index"));
	self.acmilan = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan#index"));
	self.acmilan6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan6#index"));
	self.acmilan7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan7#index"));
   	self.acmilan2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan2#index"));
    	self.acmilan3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan3#index"));
	self.acmilan4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan4#index"));
	self.acmilan5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan5#index"));
	self.acmilanActive = true;
	self.acmilan6Active = false;
	self.acmilan7Active = false;
	self.acmilan2Active = true;
	self.acmilan3Active = true;
	self.acmilan4Active = false;
	self.acmilan5Active = true;
	

	self.wom = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wom#index"));
	self.wom2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wom2#index"));

	self.capacityBackup = self.capacity; 
	self.capacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.capacity"), 0.0);
	self.capacity2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.capacity2"), 0.0);
	

	local rotationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation1#index"));
    	if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
        self.rotation1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#touchRotLimit"), 10));
    end;
	local rotationNodePartlewe = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lewe#index"));
    	if rotationNodePartlewe ~= nil then
        self.rotationPartlewe = {};
        self.rotationPartlewe.node = rotationNodePartlewe;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.lewe#minRot"));
        self.rotationPartlewe.minRot = {};
        self.rotationPartlewe.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartlewe.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartlewe.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.lewe#maxRot"));
        self.rotationPartlewe.maxRot = {};
        self.rotationPartlewe.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartlewe.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartlewe.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartlewe.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.lewe#rotTime"), 2)*1000;
        self.rotationPartlewe.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.lewe#touchRotLimit"), 10));
    end;  
	local rotationNodePartprawe = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.prawe#index"));
    	if rotationNodePartprawe ~= nil then
        self.rotationPartprawe = {};
        self.rotationPartprawe.node = rotationNodePartprawe;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.prawe#minRot"));
        self.rotationPartprawe.minRot = {};
        self.rotationPartprawe.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartprawe.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartprawe.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.prawe#maxRot"));
        self.rotationPartprawe.maxRot = {};
        self.rotationPartprawe.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartprawe.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartprawe.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartprawe.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.prawe#rotTime"), 2)*1000;
        self.rotationPartprawe.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.prawe#touchRotLimit"), 10));
    end; 
 	local rotationPartNodeleftDoor = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.leftDoor#index"));
    	if rotationPartNodeleftDoor ~= nil then
        self.rotationPartleftDoor = {};
        self.rotationPartleftDoor.node = rotationPartNodeleftDoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartleftDoor#minRot"));
        self.rotationPartleftDoor.minRot = {};
        self.rotationPartleftDoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftDoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftDoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.leftDoor#maxRot"));
        self.rotationPartleftDoor.maxRot = {};
        self.rotationPartleftDoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftDoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftDoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartleftDoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftDoor#rotTime"), 2)*1000;
        self.rotationPartleftDoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftDoor#touchRotLimit"), 10));
    end;
 	local rotationPartNoderightdoor = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rightdoor#index"));
    	if rotationPartNoderightdoor ~= nil then
        self.rotationPartrightdoor = {};
        self.rotationPartrightdoor.node = rotationPartNoderightdoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartrightdoor#minRot"));
        self.rotationPartrightdoor.minRot = {};
        self.rotationPartrightdoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightdoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightdoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rightdoor#maxRot"));
        self.rotationPartrightdoor.maxRot = {};
        self.rotationPartrightdoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightdoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightdoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartrightdoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightdoor#rotTime"), 2)*1000;
        self.rotationPartrightdoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightdoor#touchRotLimit"), 10));
    end; 
	local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation2#index"));
    	if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
        self.rotation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#touchRotLimit"), 10));
    end;
	local burtNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.burt#index"));
   	 if burtNode ~= nil then
        self.burt = {};
        self.burt.node = burtNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.burt#minRot"));
        self.burt.minRot = {};
        self.burt.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.burt.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.burt.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.burt#maxRot"));
        self.burt.maxRot = {};
        self.burt.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.burt.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.burt.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.burt.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.burt#rotTime"), 2)*1000;
        self.burt.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.burt#touchRotLimit"), 10));
    end;	

 
end;

function SipmaN2479:update(dt)

	local doRotate = self.rotation1Max or self.rotation1Min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
    end;


   	if self.trybbale then
		self.rotationMaxprawe = true;
		self.rotationMaxlewe = true;
		self.rotationMaxleftDoor = true;
   	else
		self.rotationMaxlewe = false;
		self.rotationMaxprawe = false;
		self.rotationMaxleftDoor = false;
         end;

	if self.fillLevel == 0 then
	   if self.wlacz then
		self.acmilan6Active = true;
		self.capacity = self.capacity2;
	else
		self.acmilan6Active = false;
		self.capacity = self.capacityBackup;
	    end;
        end;

	local doRotate = self.rotation2Max or self.rotation2Min 
	if self.rotation2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
        setRotation(self.rotation2.node, unpack(newRot));
    end;
	if self.rotationPartprawe ~= nil then
        local x, y, z = getRotation(self.rotationPartprawe.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartprawe.maxRot, self.rotationPartprawe.minRot, 3, self.rotationPartprawe.rotTime, dt, not self.rotationMaxprawe);
        setRotation(self.rotationPartprawe.node, unpack(newRot));
    end;
	if self.rotationPartlewe ~= nil then
        local x, y, z = getRotation(self.rotationPartlewe.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartlewe.maxRot, self.rotationPartlewe.minRot, 3, self.rotationPartlewe.rotTime, dt, not self.rotationMaxlewe);
        setRotation(self.rotationPartlewe.node, unpack(newRot));
    end;
	if self.rotationPartrightdoor ~= nil then
	local x, y, z = getRotation(self.rotationPartrightdoor.node);
	local rot = {x,y,z};
	local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartrightdoor.maxRot, self.rotationPartrightdoor.minRot, 3, self.rotationPartrightdoor.rotTime, dt, not self.rotationMaxrightdoor);
	setRotation(self.rotationPartrightdoor.node, unpack(newRot));
    end;
	if self.rotationPartleftDoor ~= nil then
	local x, y, z = getRotation(self.rotationPartleftDoor.node);
	local rot = {x,y,z};
	local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartleftDoor.maxRot, self.rotationPartleftDoor.minRot, 3, self.rotationPartleftDoor.rotTime, dt, not self.rotationMaxleftDoor);
	setRotation(self.rotationPartleftDoor.node, unpack(newRot));
    end;
	local doRotate = self.burtMax or self.burtMin 
	if self.burt ~= nil and doRotate then
        local x, y, z = getRotation(self.burt.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.burt.maxRot, self.burt.minRot, 3, self.burt.rotTime, dt, not self.burtMax);
        setRotation(self.burt.node, unpack(newRot));
     end;

	 setVisibility(self.acmilan, self.acmilanActive);
 	 setVisibility(self.acmilan6, self.acmilan6Active);
 	 setVisibility(self.acmilan7, self.acmilan7Active);
   	 setVisibility(self.acmilan2, self.acmilan2Active);
   	 setVisibility(self.acmilan3, self.acmilan3Active);
	 setVisibility(self.acmilan4, self.acmilan4Active);
	 setVisibility(self.acmilan5, self.acmilan5Active);
		
 
	--------------------------ADAPTER-------------------------
	if self.isTurnedOn and self.walek ~= nil then
		rotate(self.walek, 0, dt*0.02, 0);
	end;
	if self.isTurnedOn and self.walek2 ~= nil then
		rotate(self.walek2, 0, dt*0.02, 0);
	end;
	if self.isTurnedOn and self.walek3 ~= nil then
		rotate(self.walek3, dt*0.02, 0, 0);
	end;
	if self.isTurnedOn and self.walek46 ~= nil then
		rotate(self.walek46, 0, 0, dt*0.02);
	end;

	if self.isTurnedOn and self.wom ~= nil then
		rotate(self.wom, 0, 0, dt*0.1);
	end;

	if self.isTurnedOn and self.wom2 ~= nil then
		rotate(self.wom2, 0, 0, dt*0.03);
	end;

end;

function SipmaN2479:delete()
end;

function SipmaN2479:mouseEvent(posX, posY, isDown, isUp, button)
end;

function SipmaN2479:keyEvent(unicode, sym, modifier, isDown)
   if self.fillLevel == 0 then
	if sym == Input.KEY_KP_3 then
		self.burtMax = isDown;
		end;
	if sym == Input.KEY_KP_6 then
		self.burtMin = isDown;
		end;
	if sym == Input.KEY_KP_4 then
		self.rotation1Max = isDown;
	end;
	if sym == Input.KEY_KP_5 then
		self.rotation1Min = isDown;
	end;
	if sym == Input.KEY_KP_1 then
		self.rotation2Max = isDown;
	end;
	if sym == Input.KEY_KP_2 then
		self.rotation2Min = isDown;
	end;
	if isDown and sym == Input.KEY_8 then
		self.trybbale = not self.trybbale;
	end;
	if isDown and sym == Input.KEY_7 then
		self.acmilan7Active = not self.acmilan7Active;
		end;
	end;
	if isDown and sym == Input.KEY_b and not self.acmilanActive == true then 
		self.isTurnedOn = not self.isTurnedOn;
	end;
	if not self.isTurnedOn then
	   if isDown and sym == Input.KEY_KP_8 then
		self.acmilanActive = not self.acmilanActive;
		self.acmilan2Active = not self.acmilan2Active;
		self.acmilan3Active = not self.acmilan3Active;
		self.acmilan4Active = not self.acmilan4Active;
	    end;
        end;
	if isDown and sym == Input.KEY_KP_7 then
		self.acmilan5Active = not self.acmilan5Active;
	end;
	if isDown and sym == Input.KEY_9 then
		self.helpPanel = not self.helpPanel;
	end;
	if isDown and sym == Input.KEY_6 then
		self.wlacz = not self.wlacz;
	end;
end;		

function SipmaN2479:draw()
	 		

if self.helpPanel then
           g_currentMission:addExtraPrintText("Wcisnij 9: Wylacz info ");
    else
          g_currentMission:addExtraPrintText("Wcisnij 9: Wlacz info");
    end;

	if self.helpPanel then
			renderText(0.72, 0.84, 0.025, "- Sipma N247 -");
			renderText(0.72, 0.84, 0.025, "- Sipma N247 -");
			renderText(0.72, 0.815, 0.02, "Nacisnij NUM 7: Wypieprz krate");
			renderText(0.72, 0.8, 0.02, "Nacisnij NUM 8: Zdejmij adapter");			
			renderText(0.72, 0.785, 0.02, "Nacisnij NUM 4/5: otworz burte");
			renderText(0.72, 0.77, 0.02, "Nacisnij NUM 1/2: otworz burte");
			renderText(0.72, 0.755, 0.02, "Nacisnij Num 3/6: otworz burte tyl");
			renderText(0.72, 0.74, 0.02, "Nacisnij 7: Plachta");
			renderText(0.72, 0.725, 0.02, "Nacisnij 6: Zakladki");
			renderText(0.72, 0.71, 0.02, "Nacisnij 8: tryb bel transport");
			renderText(0.755, 0.69, 0.02, "by Grzegorz056 & Bociek");
			renderText(0.72, 0.815, 0.02, "Nacisnij NUM 7: Wypieprz krate");
			renderText(0.72, 0.8, 0.02, "Nacisnij NUM 8: Zdejmij adapter");			
			renderText(0.72, 0.785, 0.02, "Nacisnij NUM 4/5: otworz burte");
			renderText(0.72, 0.77, 0.02, "Nacisnij NUM 1/2: otworz burte");
			renderText(0.72, 0.755, 0.02, "Nacisnij Num 3/6: otworz burte tyl");
			renderText(0.72, 0.74, 0.02, "Nacisnij 7: Plachta");
			renderText(0.72, 0.725, 0.02, "Nacisnij 6: Zakladki");
			renderText(0.72, 0.71, 0.02, "Nacisnij 8: tryb bel transport");
			renderText(0.755, 0.69, 0.02, "by Grzegorz056 & Bociek");
		end;
end;

function SipmaN2479:onAttach()
end; 	

function SipmaN2479:onLeave()

	self.acmilansActive = true;
	self.acmilan6sActive = false;
	self.acmilan7sActive = false;
	self.acmilan2sActive = true;
	self.acmilan3sActive = true;
	self.acmilan4sActive = false;
	self.acmilan5sActive = true;
end;

function SipmaN2479:onDetach()
	
end;